Bug 760108 - ibus-m17n m17n:ru:phonetic needs us layout.
ibus-m17n m17n:ru:phonetic needs us layout.
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: ibus (Show other bugs)
16
Unspecified Unspecified
unspecified Severity medium
: ---
: ---
Assigned To: fujiwara
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-12-05 08:03 EST by niklas.laxstrom+bro@gmail.com
Modified: 2013-02-20 01:18 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-13 21:24:53 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description niklas.laxstrom+bro@gmail.com 2011-12-05 08:03:40 EST
Description of problem:
Since I upgrades to F16, I'm unable to have Finnish keyboard layout unless I close ibus. Looks like there is no longer option to toggle ibus off, and that it handles normal keyboard layouts too.

I however have the option "Use system keyboard layout" disabled in ibus, because using other input methods like Russian is not possible with Finnish keyboard layout, some of the letters cannot be typed then.

Essentially I cannot use ibus to type in other languages because I cannot write properly in my own language if ibus is running.

Version-Release number of selected component (if applicable):
F16 (KDE), Ibus 1.4.0


How reproducible:
Always
Comment 1 fujiwara 2011-12-07 04:06:31 EST
(In reply to comment #0)

Probably I don't understand your problem.

Do you use the latest ibus?
Currently ibus-1.4.0-11 or ibus-1.4.0-14 is available.
# yum install ibus
% rpm -q ibus
ibus-1.4.0-11.fc16.x86_64

Did you configure the system keyboard settings using 'systemsettings' command?

If you run '/usr/libexec/ibus-xkb --get' when ibus-daemon is running, what is shown?

% /usr/libexec/ibus-xkb --help
% /usr/libexec/ibus-xkb --get
layout: in,us,jp
model: eng,euro,
option: ctrl:swapcaps,grp:shift_caps_toggle,compose:rctrl

Actually ibus runs 'ibus-xkb -l ${layout} -m ${model} -o ${option}' internally.
Comment 2 niklas.laxstrom+bro@gmail.com 2011-12-07 04:16:20 EST
> rpm -q ibus
ibus-1.4.0-11.fc16.x86_64

> Did you configure the system keyboard settings using 'systemsettings' command?
I most likely chose Finnish keyboard layout from the installer around F13 or so when I first installed Feedora.

> /usr/libexec/ibus-xkb --get
/usr/libexec/ibus-xkb --get
layout: fi
model: 
option: terminate:ctrl_alt_bksp

With xev I can see that input is correctly öä when I press those keys, but what actually appears everywhere is ;' just like what would be there in US keyboard.
Comment 3 fujiwara 2011-12-07 05:09:13 EST
(In reply to comment #2)
> > /usr/libexec/ibus-xkb --get
> /usr/libexec/ibus-xkb --get
> layout: fi
> model: 
> option: terminate:ctrl_alt_bksp
> 
> With xev I can see that input is correctly öä when I press those keys, but what
> actually appears everywhere is ;' just like what would be there in US keyboard.

Hmm.., I cannot reproduce your problem. I can show 'öä' with ;' keys.

ibus just gets the current system keyboard layouts.
1. Enable 'Use system keyboard layout' and close ibus-setup.
2. Choose [Quit] menu item on ibus status icon menu and exit ibus at once.
3. Set 'fi' layout.
% /usr/libexec/ibus-xkb -l fi -o terminate:ctrl_alt_bksp
4. Check the current layout.
% /usr/libexec/ibus-xkb --get
layout: fi
model: 
option: terminate:ctrl_alt_bksp
5. Run ibus-daemon
% ibus-daemon --xim &
6. Check the current layout again.
% /usr/libexec/ibus-xkb --get
layout: fi
model: 
option: terminate:ctrl_alt_bksp

How is the result about 'öä'?
Comment 4 niklas.laxstrom+bro@gmail.com 2011-12-07 05:52:04 EST
(In reply to comment #3)
> 1. Enable 'Use system keyboard layout' and close ibus-setup.

I don't want to enable that! With that setting I'm unable to type Russian properly. If I can't type other languages, I might as well not use ibus in the first place.
Comment 5 fujiwara 2011-12-07 20:07:39 EST
(In reply to comment #4)
> (In reply to comment #3)
> > 1. Enable 'Use system keyboard layout' and close ibus-setup.
> 
> I don't want to enable that! With that setting I'm unable to type Russian
> properly. If I can't type other languages, I might as well not use ibus in the
> first place.

Can you explain what is your problem with detail when you type Russian?
Probably I'd think the system keyboard needs to be enabled in your env.
Comment 6 niklas.laxstrom+bro@gmail.com 2011-12-08 01:37:09 EST
It is impossible to type ю with the "Use system keyboard" setting enabled. On US keyboard it comes from the key before "1" which makes "`". On Finnish keyboard that comes from a key between "?" and question mark. Even if that wouldn't be a cumbersome place to type ю, it doesn't even work since it is a dead key, meaning that I have to press space to get plain `, otherwise I get something like à depending which key I press. It just doesn't work with ibus.
Comment 7 fujiwara 2011-12-08 05:14:35 EST
(In reply to comment #6)
> It is impossible to type ю with the "Use system keyboard" setting enabled. On
> US keyboard it comes from the key before "1" which makes "`". On Finnish
> keyboard that comes from a key between "?" and question mark. Even if that
> wouldn't be a cumbersome place to type ю, it doesn't even work since it is a
> dead key, meaning that I have to press space to get plain `, otherwise I get
> something like à depending which key I press. It just doesn't work with ibus.

I don't understand how you need to type 'ю'.
I checked Finnish keyboard:
http://en.wikipedia.org/wiki/Keyboard_layout#Finnish_multilingual
It seems it has no 'ю' key.
Also I don't understand a key between "?" and question mark.
"?" is not a question mark?
Comment 8 niklas.laxstrom+bro@gmail.com 2011-12-08 05:18:54 EST
I'm trying to tell you that ibus is useless with the "Use system keyboad" setting, because I cannot use other input methods like Russian properly with Finnish keyboard mapping.

On the other hand I cannot use my regular keyboard layout without the "Use system keyboard" setting if ibus is running. In F15 I just used ctrl+space to turn ibus off, but that is not possible anymore, even the xkb layouts go through ibus, which takes the "Use system keyboard" setting into account.

question mark should have read backspace.
Comment 9 fujiwara 2011-12-08 05:36:28 EST
(In reply to comment #8)
> I'm trying to tell you that ibus is useless with the "Use system keyboad"
> setting, because I cannot use other input methods like Russian properly with
> Finnish keyboard mapping.

So I don't understand how you type 'ю'.
Why don't you add Russian layout?
It seems you configure 'fi' only with KDE systemsettings.
You could set XKB two layouts 'fi' and 'ru' with XKB options.

> On the other hand I cannot use my regular keyboard layout without the "Use
> system keyboard" setting if ibus is running. In F15 I just used ctrl+space to
> turn ibus off, but that is not possible anymore, even the xkb layouts go
> through ibus, which takes the "Use system keyboard" setting into account.

Yes, now we try to integrate both XKB and input methods in one place.

> question mark should have read backspace.

Did you mistake?
Comment 10 niklas.laxstrom+bro@gmail.com 2011-12-08 05:42:12 EST
Clarification: I don't use ru XKB, I use ru-phonetic from m17n.
Comment 11 fujiwara 2011-12-08 05:51:52 EST
It seems the bug report is not good for me since it doesn't give the basic information.
I will read this tomorrow again.
Comment 12 fujiwara 2011-12-09 02:03:39 EST
I understood the problem.
The current design(f16) is to apply the previous keymap to the next input method.
E.g. if you switch 'us' layout to an IM engine, IM engine is run under us layout.
If you switch 'fi' layout to IM engine, IM engine is run under fi layout.
But m17n:ru:phonetic is defined with 'us' layout.

The ibus engine has the property of the keymap but currently it's ignored to apply the previous keymap.

I will add an exception in ibus for ibus-m17n only to fix this bug and 'Use system keyboard' still needs to be enabled since we'd like to delete it in the future.

However I'd suggest to configure multiple XKB keymaps without ibus-m17n m17n:ru:phonetic because I'd think adding an exception is not straight for ibus.
If you configure XKB keymaps 'fi' and 'ru(phonetic)' in KDE systemsettings, now ibus can shows the two keymaps as ibus engines and you can switch them in ibus, too.

I have a plan to upstream 'default' layout in engine.layout in the future.
Comment 13 fujiwara 2011-12-12 05:31:02 EST
When I investigated the case of enabled 'Use system keyboard', I found another problem.

I still think the solution in enabled 'Use system keyboard' but now I need to know what is the problem when 'Use system keyboard' is disabled.

I use an 'us' physical keyboard.
When the keymap is 'fi', 'Use system keyboard' is disabled and m17n:ru:phonetic is enabled, I can type almost Russian keys.

Which keys cannot be typed in your environment?

The following is my result:
ю1234567890+ч
явертыуиопшщэ
асдфгхйклöä
зьцжбнм,.-

I noticed the '+' and '-' are wrong but I could type 'ю'.

Is this your problem?
Comment 14 niklas.laxstrom+bro@gmail.com 2011-12-12 08:43:11 EST
* I use fin/swe physical keyboard.
* "Use system keyboard" is checked
* System keyboard: fi

Using phonetic russian from m17n:

§1234567890Ч´
явертыуиопå¨
асдфгхйклöä'
<зьцжбнм,.-

As you can see many letters are missing. ´¨' are the dead keys and what they print if I press them twice.

If I disable the "Use system keyboard" I get:

ю1234567890+ч
явертыуиопшщ
асдфгхйклöäэ
<зьцжбнм,.-

There are probably also differences in shift and altgr states.
Comment 15 fujiwara 2011-12-12 20:28:43 EST
(In reply to comment #14)
> * I use fin/swe physical keyboard.
> * "Use system keyboard" is checked
> * System keyboard: fi
> 
> Using phonetic russian from m17n:
> 
> §1234567890Ч´
> явертыуиопå¨
> асдфгхйклöä'
> <зьцжбнм,.-

Yes, I know this problem.
I'm asking the disabled 'Use system keyboard' instead.

> 
> As you can see many letters are missing. ´¨' are the dead keys and what they
> print if I press them twice.
> 
> If I disable the "Use system keyboard" I get:
> 
> ю1234567890+ч
> явертыуиопшщ
> асдфгхйклöäэ
> <зьцжбнм,.-
> 
> There are probably also differences in shift and altgr states.

So are your problems that '+', '-' and shift and altgr states?
Comment 16 Daiki Ueno 2011-12-14 02:42:30 EST
Niklas,

I have talked with fujiwara-san and implemented a fix in ibus-m17n side.  That emulates US keyboard layout based only on keycodes (not keysyms).

Could you try a test RPM?

http://ueno.fedorapeople.org/ibus-m17n/ibus-m17n-1.3.3-8.fc16.x86_64.rpm

Patch: https://github.com/ueno/ibus-m17n/commit/f95a310
SRPM: http://ueno.fedorapeople.org/ibus-m17n/ibus-m17n-1.3.3-8.fc16.src.rpm
Comment 17 fujiwara 2011-12-30 00:26:09 EST
Niklas Laxström:

Can you confirm my question?

(In reply to comment #15)
> (In reply to comment #14)
> > There are probably also differences in shift and altgr states.
> 
> So are your problems that '+', '-' and shift and altgr states?
Comment 18 niklas.laxstrom+bro@gmail.com 2011-12-31 05:18:41 EST
Sorry I've been too busy and lazy to test the RPM.

The problem is that with the "Use system keyboard (fi)" setting, when I try to type with ru-phonetic, I get the first of the keyboard listings, which does not have ю, ш or щ.

But I obviously need to have that setting enabled, or I can't type Finnish because the default US layout that is used when that setting is disabled does not contain letters ö,ä, or å.

This is still valid with ibus 1.4.0.
Comment 19 fujiwara 2012-01-04 22:59:06 EST
(In reply to comment #18)
> The problem is that with the "Use system keyboard (fi)" setting, when I try to
> type with ru-phonetic, I get the first of the keyboard listings, which does not
> have ю, ш or щ.
> 
> But I obviously need to have that setting enabled, or I can't type Finnish
> because the default US layout that is used when that setting is disabled does
> not contain letters ö,ä, or å.
> 
> This is still valid with ibus 1.4.0.

You didn't reply my question yet.
I understood the problem when the system keyboard is enabled. You don't have to repeat the same problem.

I'm asking the problem when the system keyboard is disabled because if the only enabled problem is fixed, you will see the same disabled problem again even if you enable the setting.

(In reply to comment #17)
> Niklas Laxström:
> 
> Can you confirm my question?
> 
> (In reply to comment #15)
> > (In reply to comment #14)
> > > There are probably also differences in shift and altgr states.
> > 
> > So are your problems that '+', '-' and shift and altgr states?

So are your problems that '+', '-' and shift and altgr states?
Comment 20 niklas.laxstrom+bro@gmail.com 2012-01-05 04:06:47 EST
I don't quite understand what you are asking. If the system keyboard is disabled, I can't type Finnish with the default xkb layout, because then it acts like an US keyboard which doesn't have å, ä or ö.

There is no problem typing Russian if the system keyboard layout setting is disabled, because those input methods usually expect US keyboard layout.
Comment 21 fujiwara 2012-01-13 01:19:48 EST
(In reply to comment #20)
> I don't quite understand what you are asking. If the system keyboard is
> disabled, I can't type Finnish with the default xkb layout, because then it
> acts like an US keyboard which doesn't have å, ä or ö.

Can you explain the problem exactly when the system keyboard is disabled. I'm thinking to downgrade this priority as I didn't get the reply.

When the system keyboard is disabled and Finnish XKB layout is used, I think you can type all chars on Finnish keyboard if ibus-m17n ru input method is disabled.
So I think it acts Finnish perfectly but does *not* act likes US keyboard.

When the system keyboard is disabled and Finnish XKB layout is used, I think you *cannot* type some Russian chars if ibus-m17n ru input method is *enabled*.

So I have the different behavior with yours.

> 
> There is no problem typing Russian if the system keyboard layout setting is
> disabled, because those input methods usually expect US keyboard layout.

I don't think so.

If the US xkb layout is used:
ю1234567890-ч
явертыуиопшщэ
асдфгхйкл;'
зьцжбнм,./

If the Finnish xkb layout is used:
ю1234567890+ч
явертыуиопшщэ
асдфгхйклöä
зьцжбнм,.-

I thnk you cannot type ;'/ with Finnish keyboard + ibus-m17n ru.
Also the position of '-' is different.

And I'm asking the problem in this case the system keyboard is disabled.

(In reply to comment #17)
So are your problems that '+', '-' and shift and altgr states?
Comment 22 Fedora End Of Life 2013-02-13 21:25:04 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.